%homework -7
%Manjit Chintalapalli.
% PCA
pictures={'1.gif','2.gif',
        '3.gif','4.gif',
        '5.gif','6.gif',
        '7.gif','8.gif',
        '9.gif','10.gif',
        '11.gif','12.gif'};
%gets the number of all the pictures    
count=numel(pictures);

%read first image to initialise stack and b
b=double(imread('1.gif'));
stck=cat(3,b);
%read all other images 
for x=2:count
   b=double(imread(char(pictures(x))));
   stck=cat(3,stck,b);
end

%converting the stack to vector
[X,R]=imstack2vectors(stck);

%finding the  principal component and the mean square error
P=princomp(X,11);
error=P.ems;


c=P.A;
dist=[];

for i=1:count
    for j=1:count
        dist(i,j) = norm(c(:,i)-c(:,j));
    end
end 
 
%Euclidean distance between principal component images
disp('Euclidean distance');
disp(dist);

%cosine distance between principal component images
cosdist=[];

for i=1:count
    for j=1:count
        cosdist(i,j) =1-(dot(c(:,i),c(:,j)))/(norm(c(:,i))*norm(c(:,j)));
    end
end

disp('Cosine distance');
disp(cosdist);

%original image needs to reconstructed
for j=1:12
    h1=P.X(:,j);
    h1=reshape(h1,100,100);
    figure;
    imshow(h1,[]);    
end

